use strict;
use CGI qw/:standard/;;
use CGI::Fast;
use Persistent;

{
    my $p = Persistent->new();
    while (new CGI::Fast) {
        
        my $filename = $ENV{SCRIPT_FILENAME};
        
        eval {            
            local $SIG{'__DIE__'};
            
            my $package = $p->valid_package_name($filename);
            my $mtime;
            
            if ($p->cached($filename, $package, \$mtime))
            {
                eval {$package->handler;};
            }
            else
            {            
                $p->eval_file($filename);
            }      
          
        };
      
        if($@) {                    
            print header;
            print start_html("Perl Error in $filename");
            print
                h1("Perl Error in $filename"),
                pre($@);                
            print end_html;                            
        }
    }
}